class Cubic
{
  float m_a;
  float m_b;
  float m_c;
  float m_d;

  float m_x0;
  float m_x1;
  float m_dist;

  Cubic( float a, float b, float c, float d, float x0, float x1 )
  {
    m_a = a;
    m_b = b;
    m_c = c;
    m_d = d;
    m_x0 = x0;
    m_x1 = x1;
    m_dist = 1.0/(m_x1 - m_x0);
  }

  boolean in( float x )
  {
    return ( (x >= m_x0) && (x <= m_x1) );
  }

  float evaluate( float x )
  {
    float t = (x - m_x0) * m_dist;
    float y = m_a + t * ( m_b + t * ( m_c + t * m_d ) );
    return y;
  }
}

