import java.util.Queue;

class Printer extends Thread{  
  Queue<PVector> newCoord; 
  int AL,BL;
  float L,newx,newy;
  Serial port=null;
  Printer(int al, int bl, float l, Serial p) { L=l; AL=al; BL=bl;  port=p;  newCoord = new LinkedList<PVector>(); 
  String[] lines = loadStrings("oldpos.txt");
  println("lines="+lines.length);
  if(lines.length>0) {
    String[] tokens = split(lines[0],' ');
    AL=int(tokens[0]);
    BL=int(tokens[1]);
    }
  }
  void a_up()   {AL--; port.write('a'); print('a'); }
  void a_down() {AL++; port.write('A'); print('A'); }
  void b_up()   {BL--; port.write('b'); print('b'); }
  void b_down() {BL++; port.write('B'); print('B'); }
  float xr(int a, int b) {return (a*a-b*b+L*L)/(2*L); }
  float yr(int a, float x) {return sqrt(abs(a*a-x*x)); } 
  int ar(float x, float y) {return int(sqrt(x*x+y*y)); }
  int br(float x, float y) {return int(sqrt((L-x)*(L-x)+y*y)); }

  void moveTo(float x, float y) {
    x*=10; y*=10; 
    float x0=xr(AL,BL); 
    float y0=yr(AL,x0); // current location
    float dx=abs(x-x0);
    float dy=abs(y-y0);
    float xs=(x0>x)?-1:1;
    float ys=(y0>y)?-1:1;
    float ep=0;
    println("X0="+x0+" Y0="+y0);
    if(dx>dy) { // let's loop on x axis
      for(float i=x0; abs(i-x)>1.0; i+=xs) {
        int newA = ar(i,y0);
        int newB = br(i,y0);
        while(newA>AL) a_down();
        while(newA<AL) a_up();
        while(newB>BL) b_down();
        while(newB<BL) b_up();
        ep+=dy;
        if( ep/2 >= dx ) { y0+=ys; ep-=dx; }
        }
      }
      else {
        for(float i=y0; abs(i-y)>1.0; i+=ys) {
        int newA = ar(x0,i);
        int newB = br(x0,i);
        while(newA>AL) a_down();
        while(newA<AL) a_up();
        while(newB>BL) b_down();
        while(newB<BL) b_up();
        ep+=dx;
        if( ep/2 >= dy ) { x0+=xs; ep-=dy; }
        }
       }
       println("\nAL="+AL+" BL="+BL);
    }
 
    void run() { // printing job is done here!!
      while(true) {
        if(newCoord.size()==0) try {
          sleep(1000);        
        } catch (InterruptedException e) {println("Exception"); }
        else { 
          PVector pv=newCoord.remove(); moveTo(pv.x,pv.y); 
          if (newCoord.size()==0) {
            PrintWriter pw = createWriter("oldpos.txt");
            pw.println(AL+" "+BL);
            pw.flush(); 
            pw.close(); 
            frame=11*25;
          } 
        }
      }
    }

    void move(float x, float y) {PVector p = new PVector(x, y);   newCoord.offer(p); }      
    void plot(PVector[] pv) { 
      float rx=random(10)*50+100;  
      float ry=random(5)*100+100;  
      for(PVector p : pv) move(100-p.x/4+rx, p.y/3.5+ry);  
  }
    boolean busy() {return newCoord.size()>0; }
}

