
class Shape {
 PVector north, south, west, east;
 PVector[] points;
 Shape(String s) {
   int xmin, xmax, ymin, ymax; xmin=ymin=1000; xmax=ymax=0;
    String[] pieces = split(s, ' ');
    points=new PVector[pieces.length/2];
    for(int i=0; i<pieces.length-1;i+=2) {
      int x = int(pieces[i]) ;   xmin=min(x,xmin); xmax=max(x,xmax);
      int y = int(pieces[i+1]) ; ymin=min(y,ymin); ymax=max(y,ymax);
      if(x==xmin) west=new PVector(x,y);
      if(y==ymin) north=new PVector(x,y);
      if(x==xmax) east=new PVector(x,y);
      if(y==ymax) south=new PVector(x,y);
      points[i/2]=new PVector(x,y);
    }
 }
 float length() {
  float total=0.0;
  for(int i=0;i<points.length-1;i++) total += points[i].dist(points[i+1]); 
  return total;
 }
 
 void writeFile(String filename) {
  PrintWriter f = createWriter("shapes/"+filename);
  for(int i=0;i<points.length;i++) f.println(points[i].x+" "+points[i].y); 
  f.flush();
  f.close();  
 }
 
 void printSVG() {
   print("<path d=\"M ");
   for(int i=0;i<points.length;i++) {
       print(points[i].x+" "+points[i].y+" "); 
       if(i<points.length-1) print (" L "); else print(" z\" ");
   }
   print("fill=\"red\" stroke=\"blue\" stroke-width=\"3\" />");
 }
 
 PVector[] splines(float STEP) {
  float[] t; //t = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
  float[] x;
  float[] y;
  Spline xSpline;
  Spline ySpline;
  x = new float[ points.length ];
  y = new float[ points.length ];
  t = new float[ points.length ];
  PVector[] result=new PVector[ int(points.length/STEP)+1 ];
  for ( int i = 0; i < points.length; ++i )
  {
    x[i] = points[i].x;
    y[i] = points[i].y;
    t[i] = i;
  }
  xSpline = new Spline( t, x );
  ySpline = new Spline( t, y ); 
  String s=new String();
  int j=0;
  for ( float i = 0; i < points.length; i += STEP )
  {
    result[j++] = new PVector(xSpline.evaluate(i), ySpline.evaluate(i));
  }
  result[result.length-1]=result[0];
  return result;
 }
 
 int area() { // shape are (if not intersecting vertices). 45000 seems a good threshold to discard as noise
   int l = points.length;
   int area = 0;
   for(int i=0; i<l-1; i++) area+=(points[i].x*points[i+1].y-points[i+1].x*points[i].y);
   return abs(area);
 }
}


