import fullscreen.*; 
import hypermedia.video.*;        //  Imports the OpenCV library
import org.openkinect.*;
import org.openkinect.processing.*;
import processing.serial.*;

FullScreen fs; 
Printer p;
PFont myFont;
Kinect kinect;
OpenCV opencv;                    //  Creates a new OpenCV Object
int k=1;
int frame=11*25;
String[] lines;
Shape sh;
int which=0;

PImage depth, copia, avg;
PImage img;

PVector[] sp;



void setup() {
  size( 640, 480 );
  // Create the fullscreen object
  fs = new FullScreen(this); 
  
  // enter fullscreen mode
  fs.enter(); 
  

  myFont = createFont("Garuda", 50);
  textFont(myFont);
  depth = createImage(640, 480, RGB);
  // avg = createImage(640,480,RGB);
  img = createImage(640, 480, RGB);
  copia = createImage(640, 480, RGB);
  kinect = new Kinect(this);
  kinect.start();
  kinect.enableDepth(true);
  kinect.enableRGB(true);
  opencv = new OpenCV( this );   
  // Printer
  println(Serial.list());
  String portName = Serial.list()[0];
  Serial port = new Serial(this, portName, 1200);
  p = new Printer( int(167/7*200), int(167/7*200), 263.5/7*200, port); 
  p.start();
}


void draw() {
  if (p.busy()==false) {
    background(0);
    int histo[] =  new int[256];
    img = kinect.getVideoImage();
    opencv.allocate(640, 480);
    depth = kinect.getDepthImage();
    copia=depth.get();
    for (int i=0;i<640*480;i++) { 
      histo[int(brightness(depth.pixels[i]))]++;
      if (brightness(copia.pixels[i])>=135 && brightness(copia.pixels[i])<=140);   
      else copia.pixels[i]=color(0);
    }
    opencv.copy(copia);
    image(img, 10, 8);
    Blob[] blobs = opencv.blobs( 15000, width*height/2, 100, true, OpenCV.MAX_VERTICES*4 ); 
    if ( blobs.length>0) {
      PVector[] d = new PVector[blobs[0].points.length];
      for ( int j=0; j<blobs[0].points.length; j++ ) {
        d[j]=new PVector(blobs[0].points[j].x, blobs[0].points[j].y);
      }
      boolean out[] = new boolean[blobs[0].points.length];
      simplify(d, 5, 0, blobs[0].points.length-1, out);
      stroke(250, 0, 0);
      int i=0;
      strokeWeight(2);
      noFill();
      String s = new String();
      for ( int j=0; j<blobs[i].points.length; j++ ) {
        if (out[j]==true) {
          s+=blobs[i].points[j].x +" "+ blobs[i].points[j].y + " ";
        }
      }     
      sh = new Shape(s);
      if (sh.area()>45000) { // ok, it's big enough, so I'll consider drawing that image
        stroke( 255 );
        strokeWeight(2 ); 
        fill(120, 100);
        sp = sh.splines(0.1);
        beginShape(); 
        for (PVector pv : sp) vertex(pv.x+4, pv.y+38); 
        endShape();
        fill(0, 255, 0); 
        strokeWeight(2);
        if (frame>0) text(floor(frame--/25), 30, 55);
        if (frame--==0) {
          k=255; 
          p.plot(sp);
         //delay(1000);
          sh.writeFile(new Date().getTime()+".txt");
          frame=11*25;
        }
        if (frame<-15 && k>0) { 
          k-=15;
        }
      }
    }
  }
  else { // just print the outline of the shape
     background(255);
     stroke(0,0,255);
     fill(0,255,0);
     beginShape(); 
     for (PVector pv : sp) vertex(pv.x+4, pv.y+38); 
     endShape();
  }
}


